'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.recoverData = recoverData;

var _lodash = require('lodash.flatten');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function recoverData(patch) {
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var pluralSchemasByKey = config.appSchema.pluralSchemasByKey;
  // options

  var options = (0, _lodash2.default)(Object.keys(patch).map(function (collectionKey) {
    // unpack
    var indexedItemKeys = pluralSchemasByKey[collectionKey].model.indexedItemKeys;

    var collection = patch[collectionKey];
    // for each
    var entityOptions = Object.keys(collection).map(function (id) {
      // unpack
      var entity = collection[id];
      // set
      var query = {};
      indexedItemKeys.forEach(function (indexedItemKey) {
        if (entity[indexedItemKey]) {
          query[indexedItemKey] = entity[indexedItemKey];
        }
      });
      // check that query worth it
      if (Object.keys(query).length > 0) {
        return { collectionName: collectionKey.slice(0, -4),
          id: id,
          query: query
        };
      }
    }).filter(function (option) {
      return option;
    });
    // return
    return entityOptions;
  }));
  // return
  return options;
}